local u=require"io"
local z=require"math"
local g=require"table"
local x=require"debug"
local j=require"luci.debug"
local a=require"string"
local s=require"coroutine"
local e=require"luci.template.parser"
local A=require"luci.jsonc"
local i=require"lucihttp"
local T=require"ubus"
local d=nil
local c,h=getmetatable,setmetatable
local v,E,y,l=rawget,rawset,unpack,select
local o,t,p,b=tostring,type,assert,error
local w,r,q,k=ipairs,pairs,next,loadstring
local m,f,O=require,pcall,xpcall
local e,e=collectgarbage,get_memory_limit
module"luci.util"
c("").__mod=function(i,e)
local n,a
if not e then
return i
elseif t(e)=="table"then
local s,s
for a,i in r(e)do if t(e[a])=="userdata"then e[a]=o(e[a])end end
n,a=f(i.format,i,y(e))
if not n then
b(a,2)
end
return a
else
if t(e)=="userdata"then e=o(e)end
n,a=f(i.format,i,e)
if not n then
b(a,2)
end
return a
end
end
local function n(e,...)
local e=h({},{__index=e})
if e.__init__ then
e:__init__(...)
end
return e
end
function class(e)
return h({},{
__call=n,
__index=e
})
end
function instanceof(e,t)
local e=c(e)
while e and e.__index do
if e.__index==t then
return true
end
e=c(e.__index)
end
return false
end
coxpt=h({},{__mode="kv"})
local e={
__mode="k",
__index=function(e,t)
local e=v(e,coxpt[s.running()]
or s.running()or 0)
return e and e[t]
end,
__newindex=function(a,e,o)
local t=coxpt[s.running()]or s.running()or 0
local i=v(a,t)
if not i then
E(a,t,{[e]=o})
else
i[e]=o
end
end
}
function threadlocal(t)
return h(t or{},e)
end
function perror(e)
return u.stderr:write(o(e).."\n")
end
function dumptable(n,s,e,i)
e=e or 0
i=i or h({},{__mode="k"})
for h,n in r(n)do
perror(a.rep("\t",e)..o(h).."\t"..o(n))
if t(n)=="table"and(not s or e<s)then
if not i[n]then
i[n]=true
dumptable(n,s,e+1,i)
else
perror(a.rep("\t",e).."*** RECURSION ***")
end
end
end
end
function pcdata(e)
local t=m"luci.xml"
perror("luci.util.pcdata() has been replaced by luci.xml.pcdata() - Please update your code.")
return t.pcdata(e)
end
function urlencode(e)
if e~=nil then
local e=o(e)
return i.urlencode(e,i.ENCODE_IF_NEEDED+i.ENCODE_FULL)
or e
end
return nil
end
function urldecode(e,t)
if e~=nil then
local t=t and i.DECODE_PLUS or 0
local e=o(e)
return i.urldecode(e,i.DECODE_IF_NEEDED+t)
or e
end
return nil
end
function striptags(t)
local e=m"luci.xml"
perror("luci.util.striptags() has been replaced by luci.xml.striptags() - Please update your code.")
return e.striptags(t)
end
function shellquote(e)
return a.format("'%s'",a.gsub(e or"","'","'\\''"))
end
function shellsqescape(t)
local e
e,_=a.gsub(t,"'","'\\''")
return e
end
function shellstartsqescape(e)
res,_=a.gsub(e,"^%-","\\-")
return shellsqescape(res)
end
function split(t,i,e,n)
i=i or"\n"
e=e or#t
local a={}
local o=1
if#t==0 then
return{""}
end
if#i==0 then
return nil
end
if e==0 then
return t
end
repeat
local i,n=t:find(i,o,not n)
e=e-1
if i and e<0 then
a[#a+1]=t:sub(o)
else
a[#a+1]=t:sub(o,i and i-1)
end
o=n and n+1 or#t+1
until not i or e<0
return a
end
function trim(e)
return(e:gsub("^%s*(.-)%s*$","%1"))
end
function cmatch(a,t)
local e=0
for t in a:gmatch(t)do e=e+1 end
return e
end
function imatch(e)
if t(e)=="table"then
local t=nil
return function()
t=q(e,t)
return e[t]
end
elseif t(e)=="number"or t(e)=="boolean"then
local t=true
return function()
if t then
t=false
return o(e)
end
end
elseif t(e)=="userdata"or t(e)=="string"then
return o(e):gmatch("%S+")
end
return function()end
end
function parse_units(t)
local e=0
local o={
y=60*60*24*366,
m=60*60*24*31,
w=60*60*24*7,
d=60*60*24,
h=60*60,
min=60,
kb=1024,
mb=1024*1024,
gb=1024*1024*1024,
kib=1000,
mib=1000*1000,
gib=1000*1000*1000
}
for t in t:lower():gmatch("[0-9%.]+[a-zA-Z]*")do
local a=t:gsub("[^0-9%.]+$","")
local t=t:gsub("^[0-9%.]+","")
if o[t]or o[t:sub(1,1)]then
e=e+a*(o[t]or o[t:sub(1,1)])
else
e=e+a
end
end
return e
end
a.split=split
a.trim=trim
a.cmatch=cmatch
a.parse_units=parse_units
function append(e,...)
for o,a in w({...})do
if t(a)=="table"then
for a,t in w(a)do
e[#e+1]=t
end
else
e[#e+1]=a
end
end
return e
end
function combine(...)
return append({},...)
end
function contains(t,e)
for a,t in r(t)do
if e==t then
return a
end
end
return false
end
function update(a,e)
for t,e in r(e)do
a[t]=e
end
end
function keys(t)
local e={}
if t then
for t,a in kspairs(t)do
e[#e+1]=t
end
end
return e
end
function clone(a,o)
local i={}
for a,e in r(a)do
if o and t(e)=="table"then
e=clone(e,o)
end
i[a]=e
end
return h(i,c(a))
end
function _serialize_table(o,i)
p(not i[o],"Recursion detected.")
i[o]=true
local n=""
local a=""
local s=0
for e,a in r(o)do
if t(e)~="number"or e<1 or z.floor(e)~=e or(e-#o)>3 then
e=serialize_data(e,i)
a=serialize_data(a,i)
n=n..(#n>0 and", "or"")..
'['..e..'] = '..a
elseif e>s then
s=e
end
end
for e=1,s do
local e=serialize_data(o[e],i)
a=a..(#a>0 and", "or"")..e
end
return a..(#n>0 and#a>0 and", "or"")..n
end
function serialize_data(e,a)
a=a or h({},{__mode="k"})
if e==nil then
return"nil"
elseif t(e)=="number"then
return e
elseif t(e)=="string"then
return"%q"%e
elseif t(e)=="boolean"then
return e and"true"or"false"
elseif t(e)=="function"then
return"loadstring(%q)"%get_bytecode(e)
elseif t(e)=="table"then
return"{ ".._serialize_table(e,a).." }"
else
return'"[unhandled data type:'..t(e)..']"'
end
end
function restore_data(e)
return k("return "..e)()
end
function get_bytecode(e)
local o
if t(e)=="function"then
o=a.dump(e)
else
o=a.dump(k("return "..serialize_data(e)))
end
return o
end
function strip_bytecode(r)
local t,t,e,i,s,l,c,u=r:byte(5,12)
local t
if e==1 then
t=function(o,t,a)
local e=0
for a=a,1,-1 do
e=e*256+o:byte(t+a-1)
end
return e,t+a
end
else
t=function(o,a,t)
local e=0
for t=1,t,1 do
e=e*256+o:byte(a+t-1)
end
return e,a+t
end
end
local function d(o)
local n,e=t(o,1,s)
local h={a.rep("\0",s)}
local r=e+n
e=e+n+i*2+4
e=e+i+t(o,e,i)*l
n,e=t(o,e,i)
for a=1,n do
local a
a,e=t(o,e,1)
if a==1 then
e=e+1
elseif a==4 then
e=e+s+t(o,e,s)
elseif a==3 then
e=e+c
elseif a==254 or a==9 then
e=e+u
end
end
n,e=t(o,e,i)
h[#h+1]=o:sub(r,e-1)
for t=1,n do
local a,t=d(o:sub(e,-1))
h[#h+1]=a
e=e+t-1
end
e=e+t(o,e,i)*i+i
n,e=t(o,e,i)
for a=1,n do
e=e+t(o,e,s)+s+i*2
end
n,e=t(o,e,i)
for a=1,n do
e=e+t(o,e,s)+s
end
h[#h+1]=a.rep("\0",i*3)
return g.concat(h),e
end
return r:sub(1,12)..d(r:sub(13,-1))
end
function _sortiter(a,o)
local e={}
local t,t
for t,a in r(a)do
e[#e+1]=t
end
local t=0
g.sort(e,o)
return function()
t=t+1
if t<=#e then
return e[t],a[e[t]],t
end
end
end
function spairs(t,e)
return _sortiter(t,e)
end
function kspairs(e)
return _sortiter(e)
end
function vspairs(e)
return _sortiter(e,function(a,t)return e[a]<e[t]end)
end
function bigendian()
return a.byte(a.dump(function()end),7)==0
end
function exec(e)
local e=u.popen(e)
local t=e:read("*a")
e:close()
return t
end
function execi(e)
local e=u.popen(e)
return e and function()
local t=e:read()
if not t then
e:close()
end
return t
end
end
function execl(e)
local a=u.popen(e)
local t=""
local e={}
while true do
t=a:read()
if(t==nil)then break end
e[#e+1]=t
end
a:close()
return e
end
local o={
"INVALID_COMMAND",
"INVALID_ARGUMENT",
"METHOD_NOT_FOUND",
"NOT_FOUND",
"NO_DATA",
"PERMISSION_DENIED",
"TIMEOUT",
"NOT_SUPPORTED",
"UNKNOWN_ERROR",
"CONNECTION_FAILED"
}
local function i(...)
if l('#',...)==2 then
local a,e=l(1,...),l(2,...)
if a==nil and t(e)=="number"then
return nil,e,o[e]
end
end
return...
end
function ubus(e,o,a)
if not d then
d=T.connect()
p(d,"Unable to establish ubus connection")
end
if e and o then
if t(a)~="table"then
a={}
end
return i(d:call(e,o,a))
elseif e then
return d:signatures(e)
else
return d:objects()
end
end
function serialize_json(e,a)
local e=A.stringify(e)
if t(a)=="function"then
a(e)
else
return e
end
end
function libpath()
return m"nixio.fs".dirname(j.__file__)
end
function checklib(e,i)
local t=m"nixio.fs"
local o=t.access('/usr/bin/ldd')
local t=t.access(e)
if not o or not t then
return false
end
local e=exec(a.format("/usr/bin/ldd %s",shellquote(e)))
if not e then
return false
end
for t,e in w(split(e))do
if e:find(i)then
return true
end
end
return false
end
local n=h({},{__mode="k"})
local function o(t,e,a,...)
if not a then
return false,t(x.traceback(e,(...)),...)
end
if s.status(e)=='suspended'then
return performResume(t,e,s.yield(...))
else
return true,...
end
end
function performResume(t,e,...)
return o(t,e,s.resume(e,...))
end
local function i(e,...)
return e
end
function coxpcall(e,o,...)
local a=s.running()
if not a then
if o==i then
return f(e,...)
else
if l("#",...)>0 then
local a,t=e,{...}
e=function()return a(y(t))end
end
return O(e,o)
end
else
local i,t=f(s.create,e)
if not i then
local e=function(...)return e(...)end
t=s.create(e)
end
n[t]=a
coxpt[t]=coxpt[a]or a or 0
return performResume(o,t,...)
end
end
function copcall(e,...)
return coxpcall(e,i,...)
end
